﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals
	Private fx As JFX
	
	Private JOGridPane As JavaObject
	
	Public PRIORITY_ALWAYS As Object
	Public PRIORITY_NEVER As Object
	Public PRIORITY_SOMETIMES As Object
	
	Public VPOS_BASELINE As Object
	Public VPOS_BOTTOM As Object
	Public VPOS_CENTER As Object
	Public VPOS_TOP As Object
	
	Public SPAN_REMAINING As Object
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	JOGridPane.InitializeNewInstance("javafx.scene.layout.GridPane", Null)
'	JOGridPane.RunMethod("setStyle", Array($"-fx-background-color:#$2{rnd(8, 9)}ffff;"$))
	
	SPAN_REMAINING = JOGridPane.GetField("REMAINING")
	
	Dim Priority As JavaObject
	Priority.InitializeStatic("javafx.scene.layout.Priority")
	PRIORITY_ALWAYS = Priority.GetField("ALWAYS")
	PRIORITY_NEVER = Priority.GetField("NEVER")
	PRIORITY_SOMETIMES = Priority.GetField("SOMETIMES")
	
	Dim VPos As JavaObject
	VPos.InitializeStatic("javafx.geometry.VPos")
	VPOS_BASELINE = VPos.GetField("BASELINE")
	VPOS_BOTTOM = VPos.GetField("BOTTOM")
	VPOS_CENTER = VPos.GetField("CENTER")
	VPOS_TOP = VPos.GetField("TOP")
	
End Sub

Public Sub getGridPane As JavaObject
	Return JOGridPane
End Sub	


'///////////////ROWS////////////////////////
#Region Rows
Public Sub Row_newRow As Object
	Return Row_newRow2(0)
End Sub

Public Sub Row_newRow2(Height As Double) As Object
	Dim Row As JavaObject
	Row.InitializeNewInstance("javafx.scene.layout.RowConstraints", Array(Height))
	Row_getRowConstraints.Add(Row)
	Return Row
End Sub

Public Sub Row_setPercentHeight(Row As Object, Percentage As Double)
	Dim j As JavaObject = Row
	j.RunMethod("setPercentHeight", Array(Percentage))
End Sub

Public Sub Row_setVgrow(Row As Object, Priority As Object)
	Dim j As JavaObject = Row
	j.RunMethod("setVgrow", Array(Priority))
End Sub

Public Sub Row_setHeightAllEqual
	For Each Row As Object In Row_getRowConstraints
		Row_setPercentHeight(Row, 100 / Row_getRowConstraints.Size)
	Next
End Sub

Public Sub Row_setPrefHeightAll(Value As Double)
	For Each Row As Object In Row_getRowConstraints
		Row_setPrefHeight(Row, Value)
	Next
End Sub

Public Sub Row_setMinHeight(Row As Object, Value As Double)
	Dim j As JavaObject = Row
	j.RunMethod("setMinHeight", Array(Value))
End Sub

Public Sub Row_setPrefHeight(Row As Object, Value As Double)
	Dim j As JavaObject = Row
	j.RunMethod("setPrefHeight", Array(Value))
End Sub

Public Sub Row_getPrefHeight(Row As Object) As Double
	Dim j As JavaObject = Row
	Return j.RunMethod("getPrefHeight", Null)
End Sub

Public Sub Row_getRowConstraints As List
	Return JOGridPane.RunMethod("getRowConstraints", Null)
End Sub

Public Sub Row_Remove(Row As Object) As Boolean
	Dim Index As Int = Row_getRowConstraints.IndexOf(Row)
	If Index > -1 Then
		Row_getRowConstraints.RemoveAt(Index)
		Return True
	End If
	Return False
End Sub

Public Sub Row_RemoveAll
	Row_getRowConstraints.Clear
End Sub
#End Region




'///////////////COLUMNS////////////////////////
#Region Columns
Public Sub Col_newColumn As Object
	Dim Column As JavaObject
	Column.InitializeNewInstance("javafx.scene.layout.ColumnConstraints", Null)
	Col_getColumnConstraints.Add(Column)
	Return Column
End Sub

Public Sub Col_newColumn2(Width As Double) As Object
	Dim Column As JavaObject
	Column.InitializeNewInstance("javafx.scene.layout.ColumnConstraints", Array(Width))
	Col_getColumnConstraints.Add(Column)
	Return Column
End Sub

Public Sub Col_setPercentWidth(Column As Object, Percentage As Double)
	Dim j As JavaObject = Column
	j.RunMethod("setPercentWidth", Array(Percentage))
End Sub

Public Sub Col_setPrefWidthAll(Value As Double)
	For Each Col As Object In Col_getColumnConstraints
		Col_setPrefWidth(Col, Value)
	Next
End Sub

Public Sub Col_setPrefWidth(Column As Object, Value As Double)
	Dim j As JavaObject = Column
	j.RunMethod("setPrefWidth", Array(Value))
End Sub

Public Sub Col_setHgrow(Column As Object, Priority As Object)
	Dim j As JavaObject = Column
	j.RunMethod("setHgrow", Array(Priority))
End Sub

Public Sub Col_setWidthAllEqual
	For Each Col As Object In Col_getColumnConstraints
		Col_setPercentWidth(Col, 100 / Col_getColumnConstraints.Size)
	Next
End Sub

Public Sub Col_getColumnConstraints As List
	Return JOGridPane.RunMethod("getColumnConstraints", Null)
End Sub

Public Sub Col_Remove(Column As Object) As Boolean
	Dim Index As Int = Col_getColumnConstraints.IndexOf(Column)
	If Index > -1 Then
		Col_getColumnConstraints.RemoveAt(Index)
		Return True
	Else
		Return False
	End If
End Sub

Public Sub Col_RemoveAll
	Col_getColumnConstraints.Clear
End Sub
#End Region


'///////////////METHODS////////////////////////
#Region Public Methods
Public Sub Add(child As Node, columnIndex As Int, rowIndex As Int)
	setContraints(child, columnIndex, rowIndex)
	getChildren.Add(child)
End Sub

Public Sub Add2(child As Node, columnIndex As Int, rowIndex As Int, colspan As Int, rowspan As Int)
	setContraints(child, columnIndex, rowIndex)
	setColumnSpan(child, colspan)
	getChildren.Add(child)
End Sub

Public Sub RemoveChild(child As Node) As Boolean
	Dim Index As Int = getChildren.IndexOf(child)
	If Index > -1 Then
		getChildren.RemoveAt(Index)
		Return True
	End If
	Return False
End Sub	

Public Sub RemoveAllChildren
	getChildren.Clear
End Sub

Public Sub getChildren As List
	Return JOGridPane.RunMethod("getChildren", Null)
End Sub

Public Sub GetChildenByPosition(Column As Int, Row As Int) As List
	Dim Nodes As List
	Nodes.Initialize
	For Each n As Node In getChildren
		Dim nRow As Int = JOGridPane.RunMethod("getRowIndex", Array(n))
		If nRow = Row Then
			Dim nCol As Int = JOGridPane.RunMethod("getColumnIndex", Array(n))
			Dim nColSpan As Int = JOGridPane.RunMethod("getColumnSpan", Array(n)) - 1
			If (nCol + nColSpan) >= Column Then
				Nodes.Add(n)
			End If	
		End If	
	Next
	Return Nodes
End Sub

Public Sub GetChildByPosition(Column As Int, Row As Int) As Node
	For Each n As Node In getChildren
		If n Is AnchorPane And JOGridPane.RunMethod("getRowIndex", Array(n)) = Row And JOGridPane.RunMethod("getColumnIndex", Array(n)) = Column Then
			Return n
		End If
	Next
	Return Null
End Sub

Public Sub GetRowIndex(n As Node) As Int
	Return JOGridPane.RunMethod("getRowIndex", Array(n))
End Sub	

Public Sub GetColumnIndex(n As Node) As Int
	Return JOGridPane.RunMethod("getColumnIndex", Array(n))
End Sub

Public Sub GetColumnSpan(n As Node) As Int
	Return JOGridPane.RunMethod("getColumnSpan", Array(n))
End Sub

Public Sub setGridLinesVisible(value As Boolean)
	JOGridPane.RunMethod("setGridLinesVisible", Array(value))
End Sub

Public Sub getGridLinesVisible As Boolean
	Return JOGridPane.RunMethod("getGridLinesVisible", Null)
End Sub

Public Sub setHgap(Value As Double)
	JOGridPane.RunMethod("setHgap", Array(Value))
End Sub

Public Sub getHgap As Double
	Return JOGridPane.RunMethod("getHgap", Null)
End Sub

Public Sub setVgap(Value As Double)
	JOGridPane.RunMethod("setVgap", Array(Value))
End Sub

Public Sub getVgap As Double
	Return JOGridPane.RunMethod("getVgap", Null)
End Sub

Public Sub setFillHeight(child As Node, Value As Boolean)
	JOGridPane.RunMethod("setFillHeight", Array(child, Value))
End Sub

Public Sub setFillWidth(child As Node, Value As Boolean)
	JOGridPane.RunMethod("setFillWidth", Array(child, Value))
End Sub

Public Sub setMargin(child As Node, Insets As Object)
	JOGridPane.RunMethod("setMargin", Array(child, Insets))
End Sub

Public Sub NewInsets(Top As Double, Right As Double, Bottom As Double, Left As Double) As Object
	Dim inset As JavaObject
	Return inset.InitializeNewInstance("javafx.geometry.Insets", Array(Top, Right, Bottom, Left))
End Sub
#End Region



'///////////////PRIVATE////////////////////////
#Region Private methods
Public Sub setContraints(child As Node, columnIndex As Int, rowIndex As Int)
	JOGridPane.RunMethod("setConstraints", Array(child, columnIndex, rowIndex))
End Sub

Public Sub setColumnSpan(child As Node, value As Int)
	value = Max(1, value)
	JOGridPane.RunMethod("setColumnSpan", Array(child, value))
End Sub

Public Sub setValignment(Child As Node, VPOS As Object)
	JOGridPane.RunMethod("setValignment", Array(Child, VPOS))
End Sub
#End Region


